; GIMP - The GNU Image Manipulation Program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Thanks to those who helped when I was stuck with some aspects of this script,
;particually Saulgoode.
;; 
;; ---------------------------------------------------------
;; *							   
;; * 		  	    Graechan's Script-Fu CHISELED
;; *							   
;; ---------------------------------------------------------
;; 




(define (apply-graechan-chiseled 	image 
									drawable 
									type
                                                text-layer
									pattern-layer 
									intensity
                                                azimut
                                                depth
									final)
                                                
 
	(let* (
			;;(text-layer 0)
			(final-layer 0)
			
			
			
			;; know the dimensions of the image
			(image-width (car (gimp-drawable-width text-layer)))
			(image-height (car (gimp-drawable-height text-layer)))
			(image-x (car (gimp-drawable-offsets text-layer)))
			(image-y (cadr (gimp-drawable-offsets text-layer)))

			(fond-layer (car (gimp-layer-new-from-drawable pattern-layer image)))
			(shadow-layer (car (gimp-layer-new-from-drawable text-layer image)))
			(text-layer-bump (car (gimp-layer-new-from-drawable text-layer image))) ;; bump servant a faire le repoussage
		)
           (gimp-context-push)          
                    
		(gimp-image-set-active-layer image pattern-layer)
           (gimp-image-raise-layer-to-top image text-layer)
		(gimp-drawable-set-visible fond-layer TRUE)
		(gimp-drawable-set-visible shadow-layer TRUE)
		(gimp-drawable-set-visible text-layer-bump TRUE)		
            
		
           ;; add layer
		(gimp-image-add-layer image fond-layer -1)
		(gimp-image-add-layer image shadow-layer -1)
		(gimp-drawable-set-name shadow-layer "chiseled-shadow")
		(gimp-image-add-layer image text-layer-bump -1)
		(gimp-drawable-set-name text-layer-bump "chiseled-bump")
				
	
		;; copy from the bottom to receive the text engraved
		(set! text-layer (car (gimp-layer-new image image-width image-height RGBA-IMAGE "chiseled-texte" 100 NORMAL)))
		(gimp-image-add-layer image text-layer -1)
		(gimp-layer-set-offsets text-layer image-x image-y)
		(gimp-rect-select image image-x image-y image-width image-height REPLACE FALSE 0)
		(gimp-edit-copy fond-layer)
		(gimp-selection-none image)
		(gimp-floating-sel-anchor (car (gimp-edit-paste text-layer 0))) ;; glue and anchor the floating selection
		
		
		
		;; select colors FG and BG
		(gimp-context-set-foreground '(255 255 255))
		(gimp-context-set-background '(0 0 0))
		
		;; complete the text layer with a gradient-shaped angular
		(gimp-layer-set-preserve-trans text-layer-bump TRUE)
		(if (= type 0) (gimp-edit-blend text-layer-bump FG-BG-RGB-MODE NORMAL-MODE GRADIENT-SHAPEBURST-ANGULAR 100 0 REPEAT-NONE FALSE FALSE 3 0.20 TRUE 0 0 image-width image-height))
		(if (= type 1) (gimp-edit-blend text-layer-bump FG-BG-RGB-MODE NORMAL-MODE GRADIENT-SHAPEBURST-SPHERICAL 100 0 REPEAT-NONE FALSE FALSE 3 0.20 TRUE 0 0 image-width image-height))
		(if (= type 2) (gimp-edit-blend text-layer-bump FG-BG-RGB-MODE NORMAL-MODE GRADIENT-SHAPEBURST-DIMPLED 100 0 REPEAT-NONE FALSE FALSE 3 0.20 TRUE 0 0 image-width image-height))
		(gimp-layer-set-preserve-trans text-layer-bump FALSE)
		
		;; apply bump map
		(plug-in-bump-map RUN-NONINTERACTIVE image text-layer text-layer-bump azimut 50 depth 0 0 0 0 TRUE FALSE LINEAR)
		
		;; delete text in the bottom-layer
		(gimp-selection-layer-alpha text-layer-bump)
		(gimp-selection-invert image)
		(gimp-edit-clear text-layer)
		(gimp-selection-none image)
		
		;; Lighting and shadow levels
		(if (> intensity 0)
			(begin
				(if (= intensity 1) (gimp-levels text-layer HISTOGRAM-VALUE 0 255 1.3 0 255))
                     (if (= intensity 1) (plug-in-gauss-iir2 RUN-NONINTERACTIVE image shadow-layer 10 10))
                     (if (= intensity 1) (gimp-layer-translate shadow-layer 5 5))
				(if (= intensity 2) (gimp-levels text-layer HISTOGRAM-VALUE 0 255 1.7 0 255))
                     (if (= intensity 2) (plug-in-gauss-iir2 RUN-NONINTERACTIVE image shadow-layer 15 15))
                     (if (= intensity 2) (gimp-layer-translate shadow-layer 5 5))
				(if (= intensity 3) (gimp-levels text-layer HISTOGRAM-VALUE 0 255 2.2 0 255)) 
                     (if (= intensity 3) (plug-in-gauss-iir2 RUN-NONINTERACTIVE image shadow-layer 3 3)) 
                     (if (= intensity 3) (gimp-layer-translate shadow-layer 5 5))
				(if (= intensity 4) (gimp-levels text-layer HISTOGRAM-VALUE 0 255 0.7 0 255)) 
                     (if (= intensity 4) (plug-in-gauss-iir2 RUN-NONINTERACTIVE image shadow-layer 15 15)) 
                     (if (= intensity 4) (gimp-layer-translate shadow-layer 5 5))
			)
		)
		
		;; merging layers and rear transparent plan
		(gimp-drawable-set-visible text-layer-bump FALSE)
		 (if (= final 0)
			(begin
                                               
				(gimp-image-remove-layer image text-layer-bump)
				(gimp-drawable-set-name fond-layer "Effet chiseled")
				(gimp-image-merge-down image shadow-layer EXPAND-AS-NECESSARY)
				(gimp-image-merge-down image text-layer EXPAND-AS-NECESSARY)
                     (gimp-image-raise-layer-to-top image (car (gimp-image-get-active-layer image)))                 
                     (gimp-image-remove-layer image pattern-layer)
                     (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY)

			)
 		)
          (if (= final 1)
			(begin
                     (gimp-drawable-set-visible text-layer-bump TRUE)
                     (gimp-image-lower-layer image text-layer-bump)                    
				(gimp-drawable-set-name fond-layer "Effet chiseled")
				(gimp-image-merge-down image text-layer-bump EXPAND-AS-NECESSARY)                                    
                     (gimp-image-remove-layer image (car (gimp-image-get-active-layer image)))              
                     (gimp-image-remove-layer image pattern-layer)
                     (gimp-image-raise-layer-to-top image shadow-layer)
                     (gimp-image-merge-down image shadow-layer EXPAND-AS-NECESSARY)
                     (gimp-image-raise-layer-to-top image text-layer)
                     (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY)
                     (gimp-image-crop image image-width image-height image-x image-y)
			)
 		)
          (if (= final 2)
			(begin
		          (gimp-image-raise-layer-to-top image (car (gimp-image-get-active-layer image)))
                     
                )
          )           

          (if (= final 3)
			(begin
				(gimp-image-remove-layer image text-layer-bump)
				(gimp-drawable-set-name fond-layer "Effet chiseled")
				(gimp-image-merge-down image shadow-layer EXPAND-AS-NECESSARY)
				(gimp-image-merge-down image text-layer EXPAND-AS-NECESSARY)                 
                     (gimp-image-raise-layer-to-top image (car (gimp-image-get-active-layer image)))
                     
			)
 		)
          
          (if (= final 4)
			(begin
                     (gimp-drawable-set-visible text-layer-bump TRUE)
		          (gimp-image-raise-layer-to-top image (car (gimp-image-get-active-layer image)))
                     (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY)
                     (gimp-image-crop image image-width image-height image-x image-y)
                     
                               
                )
          )           

                      
		
          (gimp-context-pop)
	)

)



;; ------------------------
;; script for <image> 
;; ------------------------

(define (script-fu-graechan-chiseled   image
										drawable 
										type
                                                     text-layer
										pattern-layer 
										intensity
                                                     azimut
                                                     depth
										final)
                                                     
  		
		(let* (
				(var-select (car (gimp-selection-is-empty image)))
				(canal 0)
			)
			
			(gimp-image-undo-group-start image)

			(if (= var-select TRUE) ;; test if there is a selection
				(begin ;; no selection was made
				)
				(begin ;; a selection was made
					(set! canal (car (gimp-selection-save image))) ;; channel storing the user's original selection
				)
			)
			
			(gimp-selection-none image)

			(apply-graechan-chiseled image drawable 
                                                       type
                                                       text-layer 
                                                       pattern-layer 
                                                       intensity 
                                                       azimut
                                                       depth
                                                       final)
	    		
			(if (= var-select TRUE) ;; test if there was a selection
				(begin ;; no selection was made
				)
				(begin ;; had a selection been made (hand over the selection of the user)
					(gimp-selection-load canal) ;; channel mask to selection
					(gimp-image-remove-channel image canal) ;; remove the mask channel
				)
			)

			(gimp-image-undo-group-end image)
	    		
			(gimp-displays-flush)
		)
)

(script-fu-register "script-fu-graechan-chiseled"
		"Chiseled 2.6"
		"A Chiseled effect using texture from the background
           background should have alpha layer"
		"Graechan"
		"Graechan"
		"18/07/2011"
		"RGBA"
        SF-IMAGE      "Image" 0
        SF-DRAWABLE   "Drawable" 0
		SF-OPTION "Type of Relief" '("Angular" "Rounded" "Concave")
		SF-LAYER "Text Layer" 0
           SF-LAYER "Pattern Layer" 0
		SF-OPTION "Intensity of Lighting" '("No Lighting" "Soft" "Medium" "Intense" "Sombre")
		SF-ADJUSTMENT "Azimut" '(135 0 360 1 10 0 0)
		SF-ADJUSTMENT "Depth" '(10 3 65 1 10 0 0)
           SF-OPTION "Final Image" '("Text with background" "Text without background" "Image with all layers" "Image with original layers" "Cropped Image")
          
)

(script-fu-menu-register "script-fu-graechan-chiseled" "<Image>/Filters/Alpha to Logo/")


(define (script-fu-chiseled-2.6-logo text 
                                     color 
                                     font 
                                     font-size 
                                     pattern
                                     type
                                     intensity
                                     azimut
                                     depth
                                     final)

  (let* ((image (car (gimp-image-new 256 256 RGB)))
         (text-layer (car (gimp-text-fontname image -1 0 0 text 20 TRUE font-size PIXELS font)))
         (text-width (car (gimp-drawable-width text-layer)))
         (text-height (car (gimp-drawable-height text-layer)))
         (pattern-layer 0)
         (graechan-chiseled 0)
         
         )
    (gimp-context-push)
    (gimp-context-set-foreground color)
    (set! pattern-layer (car (gimp-layer-new image text-width text-height RGBA-IMAGE "Pattern" 100 NORMAL-MODE)))
    (gimp-context-set-pattern pattern)
    (gimp-drawable-fill pattern-layer PATTERN-FILL)
    (gimp-image-add-layer image pattern-layer 1)
    (gimp-image-resize-to-layers image)
    (gimp-image-set-active-layer image text-layer);;test-OK
    ;;(gimp-image-raise-layer-to-top image pattern-layer);;test-OK
    (gimp-context-pop)

    (gimp-image-undo-disable image)
    (apply-graechan-chiseled image text-layer type text-layer pattern-layer intensity azimut depth final)
    (gimp-image-undo-enable image)
    
    (gimp-display-new image)
    )
  ) 
(script-fu-register "script-fu-chiseled-2.6-logo"
  "chiseled-2.6-logo"
  "A chiseled text using texture from a pattern"
  "Graechan"
  "Graechan"
  "July 2011"
  ""
  SF-STRING     "Text"               "Chisled 2.6!"
  SF-COLOR      "Text color"         '(0 0 0)
  SF-FONT       "Font"               "Sans Bold"
  SF-ADJUSTMENT "Font size (pixels)" '(100 6 200 1 1 0 1)
  SF-PATTERN    "Pattern"            "Pink Marble"
  SF-OPTION "Type of Relief" '("Angular" "Rounded" "Concave")
  SF-OPTION "Intensity of Lighting" '("No Lighting" "Soft" "Medium" "Intense" "Sombre")
  SF-ADJUSTMENT "Azimut" '(135 0 360 1 10 0 0)
  SF-ADJUSTMENT "Depth" '(10 3 65 1 10 0 0)
  SF-OPTION "Final Image" '("Text with background" "Text without background" "Image with all layers")
  )
(script-fu-menu-register "script-fu-chiseled-2.6-logo"
  "<Image>/File/Create/Logos"
  )

